---
- name: catalyst_backup
  hosts: Switch_Group
  gather_facts: true
  tasks:
    # This task will backup the configuration
  - name: backup cisco ios configuration
    cisco.ios.config:
      backup: true
      backup_options:
        dir_path: /tmp/
        filename: "{{ inventory_hostname }}.txt"
    register: config_output

  # This task removes the Current configuration... from the top of IOS routers show run
  - name: remove non config lines - regexp
    lineinfile:
      path: "{{ config_output.backup_path }}"
      line: "Building configuration..."
      state: absent
    delegate_to: localhost

  - name: create time stamp for play
    set_fact:
      datetime: "{{ lookup('pipe','date +%Y-%m-%d-%H-%M') }}"
    delegate_to: local_vm
    delegate_facts: true
    run_once: true

  - name: Create a directory if it does not exist
    ansible.builtin.file:
      path: /root/backups/catalyst/
      state: directory
    delegate_to: local_vm
    become: true
    run_once: true

  - name: save configuration to backup server
    copy:
      src: "{{ config_output.backup_path }}"
      dest: "/root/backups/catalyst/{{hostvars['local_vm'].datetime}}/"
    when: config_output is defined
    become: true
    delegate_to: local_vm
